"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWebview = require("react-native-webview");

var _reactNativeDeviceInfo = _interopRequireDefault(require("react-native-device-info"));

var _uri = require("./utils/uri");

var _NativeService = _interopRequireDefault(require("./services/NativeService"));

var _reactNative = require("react-native");

var _LoadingService = _interopRequireDefault(require("./services/LoadingService"));

var _LeaveService = _interopRequireDefault(require("./services/LeaveService"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var userAgent = _reactNativeDeviceInfo["default"].getUserAgent() + " - UEAT Native App - " + _reactNativeDeviceInfo["default"].getBundleId() + " - " + _reactNativeDeviceInfo["default"].getVersion();

function UEATRestaurant(_a) {
  var apiKey = _a.apiKey,
      culture = _a.culture,
      isMarketplace = _a.isMarketplace,
      renderError = _a.renderError,
      renderLoading = _a.renderLoading,
      onLeave = _a.onLeave;

  var _b = (0, _react.useState)(true),
      loading = _b[0],
      setLoading = _b[1];

  var _c = (0, _react.useState)(false),
      error = _c[0],
      setError = _c[1];

  var webviewRef = (0, _react.useRef)();
  var nativeServiceRef = (0, _react.useRef)(new _NativeService["default"]());
  var setWebviewRef = (0, _react.useCallback)(function (ref) {
    webviewRef.current = ref;
    nativeServiceRef.current.webview = webviewRef.current;
  }, []);
  (0, _react.useEffect)(function () {
    _LoadingService["default"].updateCallback(setLoading);
  }, []);
  (0, _react.useEffect)(function () {
    _LeaveService["default"].updateCallback(onLeave);
  }, [onLeave]);
  var retry = (0, _react.useCallback)(function () {
    setLoading(true);
    setError(false);
    webviewRef.current.reload();
  }, []);
  var onErrorInner = (0, _react.useCallback)(function () {
    setError(true);
    setLoading(false);
  }, []);
  var onMessageInner = (0, _react.useCallback)(function (e) {
    nativeServiceRef.current.onMessage(e, {
      apiKey: apiKey,
      culture: culture,
      isMarketplace: isMarketplace
    });
  }, [nativeServiceRef.current, apiKey, culture]);
  var uri = (0, _uri.generateRestaurantURL)({
    apiKey: apiKey,
    culture: culture,
    isMarketplace: isMarketplace
  });
  return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react["default"].createElement(_reactNativeWebview.WebView, {
    userAgent: userAgent,
    bounces: false,
    originWhitelist: ['*'],
    source: {
      uri: uri
    },
    renderError: function renderError() {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
    },
    renderLoading: function renderLoading() {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
    },
    onError: onErrorInner,
    onMessage: onMessageInner,
    ref: setWebviewRef
  }), loading && !!renderLoading && /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: styles.spinner
  }, renderLoading), error && !!renderError && /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: styles.spinner
  }, renderError(retry)));
}

UEATRestaurant.defaultProps = {
  isMarketplace: false
};

var styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1
  },
  spinner: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    justifyContent: 'center',
    alignItems: 'center'
  }
});

var _default = UEATRestaurant;
exports["default"] = _default;